/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2006  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include "stdafx.h"
#include "TA3D_NameSpace.h"
#include "cLogger.h"

// global variables:
TA3D::TA3DCONFIG		*TA3D::VARS::lp_CONFIG;
TA3D::INTERFACES::GFX	*TA3D::VARS::gfx;						// The gfx object we will use to draw basic things and manage fonts, textures, ...
RGB						*TA3D::VARS::pal; 

namespace TA3D
{
      // TODO: Construct global config manager class.
      // TODO: Construct global GFX object.
	char *replace_chars(char *str)
	{
		byte *cur_c = (byte*) str;
		while(cur_c[0]!=0) {
			switch(cur_c[0])
			{
			case 232:
			case 233:
				cur_c[0]='e';	break;
			case 195:
			case 224:
				cur_c[0]='a';	break;
			case 231:
				cur_c[0]='c';	break;
			case 244:
				cur_c[0]='o';	break;
			};
			cur_c++;
			}
		return str;
	}

	// Cire: Useful malloc operation.
	void *GetMem( sint32 size, sint32 zero )
	{
		void *result;

		if( zero )
			result = calloc( size, 1 );
		else
			result = malloc( size );

		/*
		TODO: Global DEBUGGER NOTIFICATION HERE.
		if( !result )
		GlobalDebugger->Failed to alloc memory for hpi
		*/
		return result;
	}

	FILE *TA3D_OpenFile( const String &FileName, const String Mode )
	{
		FILE *file;

#if defined TA3D_PLATFORM_WINDOWS
		errno_t err;
		if( ( err = fopen_s( &file, FileName.c_str(), Mode.c_str() )) == 0 )
			return file;
#else
		file=fopen( FileName.c_str(), Mode.c_str() );
		if( file )
			return file;
#endif
		return NULL;
	}

	String RemoveComments( String &sstring )
	{
		String Result = String( sstring );
		int i = (int)Result.find("//");
		if( i != -1 ) {					// If we have found comments, then remove them and clear the string (remove blanks)
			Result.resize(i);		// Remove comments

			for( i = Result.length()-1 ; i>=0 ; i--)				// Find blanks at the end of the string
				if( Result[i] != 9 && Result[i] != 32 ) {	i++;	break;	}

			if( i < Result.length() )	Result.resize(i);			// Remove them

			for( i = 0 ; i<Result.length() ; i++)				// Find blanks at the beginning of the string
				if( Result[i] != 9 && Result[i] != 32 ) {	i--;	break;	}

			if( i >= 0 )
				Result.erase( 0, i );
			}
		return Result;
	}

	Vector< String > ReadVectorString( String base_str )			// Reads something like string1, string2, string3, string4, ..., string n to make a vector of string{i}
	{
		Vector< String >	result;

		while( base_str != "" ) {			// Reads the whole string
			int i = base_str.find( "," );
			if( i == -1 ) {
				result.push_back( TrimString( base_str ) );
				base_str = "";
				}
			else {
				String tmp = base_str.substr( 0, i );
				result.push_back( TrimString( tmp ) );
				base_str = base_str.substr( i+1, base_str.size() - i - 1 );
				}
			}

		return result;
	}

	bool TA3D_exists( const String &filename )			// just a wrapper for allegro's exists function which only use C strings
	{
		return exists( filename.c_str() );
	}
}
