/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2005  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#pragma once

#include "hash_table.h"

namespace TA3D
{
	namespace UTILS
	{
		class cTAFileParser : protected TA3D::UTILS::cHashTable< String >
		{
		private:
			std::string m_cKey;     // used when building keys.
			bool m_bKeysCaseSenstive;	// Is it case sensitive ?

			void ProcessData( String &Data );
			String GetLine( const String &Data );

		protected:
			// A hash map of key/values

		public:
			void Load( const String &FileName, bool bClearTable=false ); 
			cTAFileParser( const String &FileName, bool bKeysCaseSenstive = false );
			cTAFileParser();
			~cTAFileParser();

			sint32	PullAsInt( const std::string &KeyName , sint32 def = 0 );
			real32	PullAsFloat( const std::string &KeyName , real32 def = 0.0f );
			String	PullAsString( const std::string &KeyName , String def = "" );
			bool	PullAsBool( const std::string &KeyName , bool def = false );
		};
	}
} 
