/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2005  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

/*-----------------------------------------------------------------------------\
|                                     intro.cpp                                |
|       Ce module contient les fonctions de l'introduction de TA3D             |
|                                                                              |
\-----------------------------------------------------------------------------*/

#ifdef CWDEBUG
#include <libcwd/sys.h>
#include <libcwd/debug.h>
#endif
#include "stdafx.h"
#include "matrix.h"
#include "TA3D_NameSpace.h"
#include "ta3dbase.h"
#include "intro.h"

#define NB_TXT_LINES	20
#define LAST_LINE		19

void play_intro(char *txt_file)
{
	GLuint glfond = gfx->load_texture("gfx/intro.jpg");

	bool done=false;

	gfx->set_2D_mode();
	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

	FILE *gpl=TA3D_OpenFile(txt_file,"rb");

	char *text_line[NB_TXT_LINES];
	int i;
	for(i=0;i<NB_TXT_LINES;i++) {
		text_line[i]=new char[100];
		text_line[i][0]=0;
		}

	float dec=0.0f;
	float dt=0.0f;
	int time=Atimer;
	float Conv=1.0f/SECS_TO_TIMER(1);
	bool read=true;

	float h = gfx->TA_font.height();

	do
	{
		do
		{
			dt=(Atimer-time)*Conv;
			rest(1);
		}while(dt<0.02f);
		time=Atimer;

		dec-=dt*h;
		if(dec<=-h) {		// Décale tout et lit une autre ligne
			dec=0.0f;
			for(i=0;i<LAST_LINE;i++) {
				text_line[i][0]=0;
				strcat(text_line[i],text_line[i+1]);
				}
			text_line[LAST_LINE][0]=0;
			if(read) {
				if(fgets(text_line[LAST_LINE],100,gpl)==NULL)
					read=false;
				if(read) {
					for(i=0;i<strlen(text_line[LAST_LINE]);i++) {
						if(text_line[LAST_LINE][i]==10 || text_line[LAST_LINE][i]==13)
							text_line[LAST_LINE][i]=0;
						if(text_line[LAST_LINE][i]==9) {
							for(int e=strlen(text_line[LAST_LINE])+4;e>i+4;e--)
								text_line[LAST_LINE][e]=text_line[LAST_LINE][e-4];
							text_line[LAST_LINE][i]=32;
							text_line[LAST_LINE][i+1]=32;
							text_line[LAST_LINE][i+2]=32;
							text_line[LAST_LINE][i+3]=32;
							}
						}
					replace_chars(text_line[LAST_LINE]);
					}
				}
			else {
				bool vide=true;
				for(i=0;i<NB_TXT_LINES;i++)
					if(text_line[i][0]!=0) {
						vide=false;
						break;
						}
				done|=vide;
				}
			}

		if(mouse_b || keypressed())	done=true;

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

		gfx->drawtexture(glfond,0.0f,0.0f,640.0f,480.0);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		gfx->print(gfx->TA_font,320.0f-0.5f*gfx->TA_font.length("Total Annihilation 3D"),80.0f,0.0f,0xFFFFFFFF,"Total Annihilation 3D");

		for(i=0;i<NB_TXT_LINES;i++)
			gfx->print(gfx->TA_font,32.0f,80.0f+(i+2)*h+dec,0.0f,text_line[i]);

		glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
		glBindTexture(GL_TEXTURE_2D,glfond);
		glBegin(GL_QUADS);
			glColor4f(1.0f,1.0f,1.0f,0.0f);
			glTexCoord2f(0.0f,(80.0f+h)/480.0f);		glVertex2f(0.0f,80.0f+h);
			glTexCoord2f(1.0f,(80.0f+h)/480.0f);		glVertex2f(640.0f,80.0f+h);
			glTexCoord2f(1.0f,(80.0f+2*h)/480.0f);		glVertex2f(640.0f,80.0f+2*h);
			glTexCoord2f(0.0f,(80.0f+2*h)/480.0f);		glVertex2f(0.0f,80.0f+2*h);

			glTexCoord2f(0.0f,(80.0f+2*h)/480.0f);		glVertex2f(0.0f,80.0f+2*h);
			glTexCoord2f(1.0f,(80.0f+2*h)/480.0f);		glVertex2f(640.0f,80.0f+2*h);
			glColor4f(1.0f,1.0f,1.0f,1.0f);
			glTexCoord2f(1.0f,(80.0f+4*h)/480.0f);		glVertex2f(640.0f,80.0f+4*h);
			glTexCoord2f(0.0f,(80.0f+4*h)/480.0f);		glVertex2f(0.0f,80.0f+4*h);

			glTexCoord2f(0.0f,(80.0f+LAST_LINE*h)/480.0f);		glVertex2f(0.0f,80.0f+LAST_LINE*h);
			glTexCoord2f(1.0f,(80.0f+LAST_LINE*h)/480.0f);		glVertex2f(640.0f,80.0f+LAST_LINE*h);
			glColor4f(1.0f,1.0f,1.0f,0.0f);
			glTexCoord2f(1.0f,(80.0f+(LAST_LINE+2)*h)/480.0f);		glVertex2f(640.0f,80.0f+(LAST_LINE+2)*h);
			glTexCoord2f(0.0f,(80.0f+(LAST_LINE+2)*h)/480.0f);		glVertex2f(0.0f,80.0f+(LAST_LINE+2)*h);

			glTexCoord2f(0.0f,(80.0f+(LAST_LINE+2)*h)/480.0f);		glVertex2f(0.0f,80.0f+(LAST_LINE+2)*h);
			glTexCoord2f(1.0f,(80.0f+(LAST_LINE+2)*h)/480.0f);		glVertex2f(640.0f,80.0f+(LAST_LINE+2)*h);
			glTexCoord2f(1.0f,(80.0f+(LAST_LINE+3)*h)/480.0f);		glVertex2f(640.0f,80.0f+(LAST_LINE+3)*h);
			glTexCoord2f(0.0f,(80.0f+(LAST_LINE+3)*h)/480.0f);		glVertex2f(0.0f,80.0f+(LAST_LINE+3)*h);
		glEnd();
		glDisable(GL_BLEND);

		gfx->flip();
	}while(!done);

	for(i=0;i<NB_TXT_LINES;i++)
		if(text_line[i])
			delete[] text_line[i];

	fclose(gpl);

	gfx->unset_2D_mode();

	glDeleteTextures(1,&glfond);
}

GLuint Glfond = 0;

void loading(float percent,char *msg)
{
	bool init=(Glfond==0);
	if(init)
		Glfond = gfx->load_texture("gfx/intro.jpg");

	gfx->set_2D_mode();
	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

	float h=gfx->TA_font.height();

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

	gfx->drawtexture(Glfond,0.0f,0.0f,640.0f,480.0);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	gfx->print(gfx->TA_font,320.0f-0.5f*gfx->TA_font.length("Total Annihilation 3D"),80.0f,0.0f,0xFFFFFFFF,"Total Annihilation 3D");

	glDisable(GL_BLEND);

	glDisable(GL_TEXTURE_2D);
	glColor3f(0.5f,0.0f,0.0f);
	glBegin(GL_QUADS);
		glVertex2f(20.0f,220.0f);
		glVertex2f(20.0f+6.0f*percent,220.0f);
		glColor3f(1.0f,0.0f,0.0f);
		glVertex2f(20.0f+6.0f*percent,240.0f);
		glVertex2f(20.0f,240.0f);

		glVertex2f(20.0f,240.0f);
		glVertex2f(20.0f+6.0f*percent,240.0f);
		glColor3f(0.5f,0.0f,0.0f);
		glVertex2f(20.0f+6.0f*percent,260.0f);
		glVertex2f(20.0f,260.0f);
	glEnd();
	glColor3f(1.0f,1.0f,1.0f);
	glBegin(GL_LINE_LOOP);
		glVertex2f(20.0f,220.0f);
		glVertex2f(620.0f,220.0f);
		glVertex2f(620.0f,260.0f);
		glVertex2f(20.0f,260.0f);
	glEnd();
	glEnable(GL_TEXTURE_2D);

	glEnable(GL_BLEND);
	gfx->print(gfx->TA_font,320.0f-0.5f*gfx->TA_font.length(msg),240-h*0.5f,0.0f,0xFFFFFFFF,msg);
	glDisable(GL_BLEND);

	gfx->flip();

	gfx->unset_2D_mode();

	if(percent>=100.0f) {
		glDeleteTextures(1,&Glfond);
		Glfond = 0;
		}
}
